keql = LibStub("AceAddon-3.0"):NewAddon("keql", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local addon = keql
local Quixote = LibStub("LibQuixote-2.0")
local L = LibStub("AceLocale-3.0"):GetLocale("keql")
local launcher
keql.launcher = launcher
local db, dbpc
--local keqldewdrop = AceLibrary("Dewdrop-2.0")
--keqlwaterfall = AceLibrary("Waterfall-1.0")
local VERSION = GetAddOnMetadata("keql", "Version")
keql.revision = VERSION
keql.versionstring = VERSION
local defaults = {
	profile = {
		disabled = {},
		tooltip = {
			showmob = true,
			showitem = true,
			activetracker = true,
			activetrackerdesc = false,
			activetrackerleft = true,
			activetrackerright = true,
		},
		questlog = {
			debug = false,
			locked = false,
			alwaysmaximize = false,
			alwaysminimize = false,
			showlevels = true,
			completeddisplay = false,
			announce = false,
			autocomplete = false,
			alpha = 1,
			fontsize = 12,
			scale = 1,
		},
		tracker = {
			locked = false,
			trackerheader = true,
			fontheight = 12,
			alpha = 1,
			addnewquests = true,
			addobjectiveupdate = true,
			showzones = true,
			removecompleted = true,
			hidecompletedobj = true,
			hidequestcompletedobj = false,
		},
		achievement = {
		
		},
		colors = {
			TrackerBGColor = {
				r = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
				g = TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,
				b = TOOLTIP_DEFAULT_BACKGROUND_COLOR.b,
				a = 1,
			},
			TrackerBorderColor = {
				r = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
				g = TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,
				b = TOOLTIP_DEFAULT_BACKGROUND_COLOR.b,
				a = 1,
			},
			ZoneColor = {
				r = 1,
				g = 1,
				b = 1,
			},
			ObjectiveColor = {
				r = 0.8,
				g = 0.8,
				b = 0.8,
			},
			ObjectiveColorCompleted = {
				r = HIGHLIGHT_FONT_COLOR.r,
				g = HIGHLIGHT_FONT_COLOR.g,
				b = HIGHLIGHT_FONT_COLOR.b,
			},
			QuestColor = {
				r = 0.75,
				g = 0.61,
				b = 0,
			},
			QuestColorCompleted = {
				r = NORMAL_FONT_COLOR.r,
				g = NORMAL_FONT_COLOR.g,
				b = NORMAL_FONT_COLOR.b,
			},
			QuestColorFailed = {
				r = 1,
				g = 0,
				b = 0,
			},
			tooltipquest = {
				r = 0.75,
				g = 0.61,
				b = 0,
			},
			tooltiptext = {
				r = 1,
				g = 1,
				b = 1,
			},
			tooltipobj = {
				r = 1,
				g = 1,
				b = 1,
			},
			QuestColorLevels = true,
			objfade = true,
		},
		--[[Color = 
		{
			BackgroundColor = {
				r = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
				g = TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,
				b = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
			},
			BackgroundCornerColor = {
				r = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,
				g = TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,
				b = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,			
			},
			Zone = {
				r = 1,
				g = 1,
				b = 1,
			},
			HeaderComplete = {
				r = NORMAL_FONT_COLOR.r,
				g = NORMAL_FONT_COLOR.g,
				b = NORMAL_FONT_COLOR.b,
			},
			HeaderEmpty = {
				r = 0.75,
				g = 0.61,
				b = 0,
			},
			HeaderFailed = {
				r = 1,
				g = 0,
				b = 0,
			},
			ObjectiveEmpty = {
				r = 0.8,
				g = 0.8,
				b = 0.8,
			},
			ObjectiveComplete = {
				r = HIGHLIGHT_FONT_COLOR.r,
				g = HIGHLIGHT_FONT_COLOR.g,
				b = HIGHLIGHT_FONT_COLOR.b,
			},
			TooltipQuestTitle = {
				r = 0.75,
				g = 0.61,
				b = 0,
			},
			TooltipDesc = {
				r = 1.0,
				g = 0.8,
				b = 0,	
			},
			TooltipPartyQuixote = {
				r = 0.4,
				g = 0.4,
				b = 1,
			},
			TooltipPartyNonQuixote = {
				r = 1,
				g = 0.4,
				b = 0.4,
			},
			TooltipPartyObj = {
				r = 0.8,
				g = 0.8,
				b = 0.8,
			},
			TooltipPartyObjComp = {
				r = HIGHLIGHT_FONT_COLOR.r,
				g = HIGHLIGHT_FONT_COLOR.g,
				b = HIGHLIGHT_FONT_COLOR.b,
			},
			ColorMobTooltip = {
				r = 0.8,
				g = 0.8,
				b = 0.8,
			},
			ColorItemTooltip = {
				r = 0.8,
				g = 0.8,
				b = 0.8,
			},
		},
		
-- QuestLog
		locked = true,
		alwaysminimize = false,
		alwaysmaximize = false,
		ShowLevels = true,
		InfoOnQuestCompletion = false,
		autocomplete = false,
		simplequestlog = false,
		QuestLogAlpha = 1,
		QuestLogScale = 1,
		forcemove = false,
		
-- QuestTracker
		lockedtracker = false,
		disabledtracker = false,
		ShowTrackerHeader = false,
		TrackerFontHeight = 12,
		CustomBackgroundColor = false,
		BackgroundAlpha = false,		
		ShowZonesInTracker = false,
		CustomZoneColor = false,
		CustomObjetiveColor = false,
		RemoveFinished = true,
		MinimizeFinished = false,
		HideCompletedOnly = false,
		CustomHeaderColor = false,
		HeaderQuestLevelColor = false,
		ShowObjectiveMarkers = true,
		UseTrackerListing = false,
		TrackerList = 0,
		TrackerSymbol = 0,
		SortTrackerItems = true,
		AddNew = true,
		AddUntracked = true,
		FadeColor = false,
		QuestTrackerAlpha = 1,
		TrackerAutoResize = true,
		TrackerFixedWidth = 250,
		
-- Tooltip
		tooltipmob = true,
		tooltipitem = true,
		activetracker = true,
		activetrackerdesc = true,		
		activetrackerleft = false,
		activetrackerright = false,
		activetrackerparty = false,
		AnnounceQuest = false,
		InfoSound = "Sound\\Interface\\GnomeExploration.wav",
		QuestLogFontSize = 12,
		TooltipTitleDiff = true,
		TooltipObjFade = true,
		TooltipItemFade = true,

-- Fubar

-- Achievementtracker
		ATrackerEnable = false,
		ATrackerToggled = false,]]
	}
}

-- Debug Function
-- #NODOC
function addon:Print(text)
    DEFAULT_CHAT_FRAME:AddMessage("keql: " ..tostring(text))
end
function addon:Error(string)
	self:Print("|cffff0000"..string.."|r")
end
function addon:Debug(string)
	if db.questlog.debug then  
		self:Print(string)
	end
end

--[[function keql:Disabletracker(value ,realy)
    if not db.disabledtracker then
        if not realy then 
		    StaticPopup_Show("CONFIRM_DISABLETRACKER")
		    keql.disabletracker = value
	    else
			db.disabledtracker = keql.disabletracker
            ReloadUI()
	    end
	else
	   db.disabledtracker = value
	   keql:InitTracker();
       keql:setmovabletracker(db.lockedtracker);
    end
end

function keql:Disableaddon(value ,realy)
    if keql:IsActive() then
        if not realy then 
		    StaticPopup_Show("CONFIRM_DISABLEADDON")
	    else
			keql:ToggleActive()
            ReloadUI()
	    end
	else
        keql:ToggleActive()
    end
end

function keql:DisableQuestLog(value ,realy)
    if not db.simplequestlog then
        if not realy then 
		    StaticPopup_Show("CONFIRM_SIMPLEQUESTLOG")
		    keql.simplequestlog = value
	    else
			db.simplequestlog = keql.simplequestlog
            ReloadUI()
	    end
	else
	   db.simplequestlog = value
	   keql:ExtendedQuestLog()
	   QuestLog_Update();
    end
end]]
-- Addon functions

function keql:OnInitialize()
	---------------------------------------------------------------------
	--- Setup Databases, Options
    self.db = LibStub("AceDB-3.0"):New("keqlDB", defaults, "global")
	db = self.db.profile
	self.dbpc = LibStub("AceDB-3.0"):New("keqlDBPC", {profile = {
		tracked = {},
	}}, "global")
	dbpc = self.dbpc.profile
	--self:RegisterChatCommand("keql", function() addon:ShowConfig() end)
	self:RegisterChatCommand("keql", function() addon:OpenOptions() end)
	local LDB = LibStub("LibDataBroker-1.1", true)
	launcher = LDB:NewDataObject("keql", {
		icon = "Interface\\Icons\\INV_Letter_03",
		label = "Quests",
		OnClick = function(clickedframe, button)
			if button == "RightButton" then addon:OpenOptions() else addon:Toggle() end
		end,
	})
	
	self:SetupOptions()
end

function addon:launcherUpdate()
	local _,questEntries = GetNumQuestLogEntries()
	if LibStub("LibCrayon-3.0") then
		text = format("|cff%s%d|r", LibStub("LibCrayon-3.0"):GetThresholdHexColor(questEntries, 0, 5, 10, 15, 20, 25), questEntries).."/25"
	else
		text = questEntries.."/25"
	end
	launcher.text = text
end


function keql:OnEnable()
	-- Check for other addons
    --keql:Compatibility()
	addon:launcherUpdate()
	--Quixote.RegisterCallback(keql, "Update", "Quixote_Update")
	--Quixote.RegisterCallback(self, "Update", "Quixote_Update")
	--Quixote.RegisterCallback(self, "Party_Update", "Quixote_PartyUpdate")
	--Quixote.RegisterCallback(self, "Quest_Lost")
	--self:SecureHook("AddQuestWatch")
	--self:SecureHook("RemoveQuestWatch")
	--addon:SecureHook("GetQuestReward")
	-- Init Questlog
	keql:InitQuestLog()
	-- Load Questtracker if used
	--if not db.disabled.tracker and not db.disabledtracker then
	keql:InitTracker()
	--end
	-- init Tooltip
	keql:InitTooltip()
	if not db.questlog.locked then
		QuestLogFrame:RegisterForDrag("LeftButton")
	end
	if not db.tracker.locked then
		QuestWatchFrame:RegisterForDrag("LeftButton")
		keql.TrackerTitleBar:RegisterForDrag("LeftButton")
	end
	if db.ATrackerEnable then
		--keql:InitAchievementTracker()
	end
	keql:SetQuestLogFontSize(db.questlog.fontsize)
end

function keql:OnDisable()
	QUESTS_DISPLAYED = 6
	keql:UnhookAll()
--	ReloadUI()
end

--------------------------------------------
-- Arguments:
-- number - quest id
-- string - quest name
--
-- Notes:
-- Prints the Quest Name/Status and Objectives to the currently opened chatbox
--
-- Returns:
-- * nothing
--------------------------------------------
function keql:AddQuestStatusToChatFrame(questIndex)
	local chatFrame = DEFAULT_CHAT_FRAME
    local chatType = chatFrame.editBox:GetAttribute("chatType")
    local oText, oType, oNumP, oNumN, oComp
    local text
    if chatType == "WHISPER" then
		chatType = "SAY"
	end
	local qTitle,qLvl,qTag,qRec,qStat,qObj,qZone,qID = keqlQ:GetQuestById(questIndex)
	if qObj and qObj > 0 then
		SendChatMessage("["..qLvl..string.upper(qTag).."] "..qTitle, chatType)
		for i=1, qObj do
			text = ""
			oText, oType, oNumP, oNumN, oComp = keqlQ:GetQuestStatusById(questIndex, i)
			text = oText
			if finished then
				text = text.." "..L["(Done)"]
			else
				text = text..": "..oNumP.."/"..oNumN
			end
			if text and strlen(text) > 0 then
				SendChatMessage(" - "..text, chatType)
			end
		end
	else
		chatFrame:AddMessage(L["No Objectives!"])
	end
	chatFrame.editBox:Hide()
end

--------------------------------------------
-- Notes:
-- Sorts the Tracked quests
--
-- Returns:
-- * nothing
--------------------------------------------
function keql:SortWatchedQuests()
	table.sort(dbpc.tracked, SortCompare)
end

local function SortCompare(first, second)
	local temp = string.gsub(first, ".+,%d+,[%[%d+%+*%]]*", "")
	local temp2 = string.gsub(second, ".+,%d+,[%[%d+%+*%]]*", "")
	if temp < temp2  then
		return true
	end
	return false
end

--------------------------------------------
-- Notes:
-- Manage Tracked Quest list
--
-- Returns:
-- * nothing
--------------------------------------------
function keql:ManageQuests()
	local tempHeaderList = {}
	local tempQuestList = {}
	local numEntries = GetNumQuestLogEntries()
	local questLogTitleText, level, questTag, isHeader, isCollapsed, isComplete
	local currentHeader = nil
	local temp, _
	
	local oldTitle
	
	if numEntries ~= 0 then
		for j=numEntries, 1, -1 do
			questLogTitleText, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(j)
			if (isHeader and isCollapsed) then
				tempHeaderList[j] = 1
				ExpandQuestHeader(j)
			end
		end
	
		numEntries = GetNumQuestLogEntries()
	
		for j=1, numEntries, 1 do
			questLogTitleText, level, questTag, _, isHeader, isCollapsed, isComplete = GetQuestLogTitle(j)
			oldTitle = self.hooks.GetQuestLogTitle(j)
			if isHeader then
				currentHeader = questLogTitleText
			else
				temp = currentHeader..","..level..","..questLogTitleText
				table.insert(tempQuestList, temp)
				if keql.TrackerQueue and keql.TrackerQueue == oldTitle then
					table.insert(dbpc.tracked, temp)
					keql.TrackerQueue = nil
				end
			end
		end	
	
		for j=1, numEntries, 1 do
			if(tempHeaderList[j] == 1) then
				CollapseQuestHeader(j)
			end
		end
	
	
		local numWatches = table.getn(dbpc.tracked)
		local numEntries = table.getn(tempQuestList)
		local found = false
		for i=numWatches, 1, -1 do
			found = false
			for j=0, numEntries, 1 do
				if dbpc.tracked[i] == tempQuestList[j] then
					found = true
					break
				end
			end
			if not found then
				table.remove(dbpc.tracked, i)
			end
		end	
	end
	keql:SortWatchedQuests()
end
function addon:GetPercentColor(percent)
	if percent <= 0 then
		return 1, 0, 0
	elseif percent <= 0.5 then
		return 1, percent*2, 0
	elseif percent >= 1 then
		return 0, 1, 0
	else
		return 2 - percent*2, 1, 0
	end
end
--------------------------------------------
-- Arguments:
-- table - Color1
-- table - Color2
-- number - Have
-- number - Needed
--
-- Notes:
-- Fades Colors between Color1 and Color2 depending on how much percent has Have from Needed
--
-- Returns:
-- * table - Color Faded
--------------------------------------------
function keql:FadeColors(tempColor, tempColor2, done, obj)
	local color = {r=0, g=0, b=0}
	local multiplier

	multiplier = (done / obj)
	color.r = tempColor.r + ((tempColor2.r - tempColor.r)*multiplier)
	color.g = tempColor.g + ((tempColor2.g - tempColor.g)*multiplier)
	color.b = tempColor.b + ((tempColor2.b - tempColor.b)*multiplier)

	return color

end

--------------------------------------------
-- Arguments:
-- number - Decimal nr
-- number - Length of number
--
-- Notes:
-- Converts a Decimal Number to Hexadecimal
--
-- Returns:
-- string - Hexadecimal number
--------------------------------------------
function keql:decToHex(Dec, Length)
	local B, K, Hex, I, D = 16, "0123456789ABCDEF", "", 0;
	while Dec>0 do
		I=I+1;
		Dec, D = math.floor(Dec/B), math.fmod(Dec,B)+1;
		Hex=string.sub(K,D,D)..Hex;
	end
	if( (Length ~= nil) and (string.len(Hex) < Length) ) then
		local temp, i = Length-string.len(Hex), 1;
		for i=1, temp, 1 do
			Hex = "0"..Hex;
		end
	end
	return Hex;
end

--------------------------------------------
-- Arguments:
-- string - text
-- number - Red Component
-- number - Green Component
-- number - Blue Component
--
-- Notes:
-- Returns a WoW-style colored text
--
-- Returns:
-- string - Text colored with WoW control characters
--------------------------------------------
function keql:ColorText(t, r, g, b)
	if ( t == nil ) then t = ""; end
	if ( r == nil ) then r = 0.0; end
	if ( g == nil ) then g = 0.0; end
	if ( b == nil ) then b = 0.0; end
	return "|CFF"..keql:decToHex(r*255, 2)..keql:decToHex(g*255, 2)..keql:decToHex(b*255, 2)..t.."|r";
end

local options = {
	type = 'group',
	name = "Extended QuestLog",
	
	args = {
-- General Options, shown on the main window
		general = {
			type	= 'group',
			order   = 1,
			name	= L["Main Options"],
			desc	= L["Main Options"],
			get = function(info) return db.questlog[ info[#info] ] end,
			set = function(info, value) db.questlog[ info[#info] ] = value end,
			args	= {
				intro = {
					order = 1,
					type = "description",
					name = L["keql_DESC"],
				},
				debug = {
					type = 'toggle',
					order = 2,
					name = L["Show Debugging Messages"],
				},
				locked = {
					type = 'toggle',
					name = L["Lock Quest Log"],
					desc = L["Makes the quest log unmovable"],
					set = function(info, value)
						db.questlog[ info[#info] ] = value
						if value then
							QuestLogFrame:RegisterForDrag(0)
						else
							QuestLogFrame:RegisterForDrag("LeftButton")
						end	
					end,
					order = 3,
				},
				alwaysmaximize = {
					type = 'toggle',
					order = 4,
					width = 'full',
					name = L["Always Open Maximized"],
					desc = L["Force the quest log to open maximized"],
					disabled = function(info) return db.questlog.alwaysminimize end,
				},
				alwaysminimize = {
					type = 'toggle',
					order = 5,
					width = 'full',
					name = L["Always Open Minimized"],
					desc = L["Force the quest log to open minimized"],
					disabled = function(info) return db.questlog.alwaysmaximize end,
				},
				showlevels = {
					type = 'toggle',
					order = 6,
					width = 'full',
					name = L["Show Quest Level"],
					desc = L["Shows the quests level"],
					set = function(info, value) db.questlog[ info[#info] ] = value QuestLog_Update() QuestWatch_Update() end,
				},
				completedisplay = {
					type = 'toggle',
					order = 7,
					width = 'full',
					name = L["Info on Quest Completion"],
					desc = L["Shows a message and plays a sound when you complete a quest"],
				},
				--[[QuestCompletionSound = {
					type = 'group',
					order = 9,
					guiInline = true,
					width = 'full',
					name = L["Completion Sound"],
					desc = L["Select the sound to be played when a quest is completed"],
					disabled = function(info) return not db.questlog.InfoOnQuestCompletion end,
					args = {
						none = {
							type = 'toggle',
							order = 1,
							width = 'full',
							name = L["No sound"],
							desc = L["Don't play a sound"],
							get = function(info) if not keql.db.profile.InfoSound or keql.db.profile.InfoSound == '' then return true else return false end end,
							set = function(info, newval) if newval then keql.db.profile.InfoSound = '' end end,
						},
						
					}
				},	]]						
				announce = {
					type = 'toggle',
					order = 9,
					width = 'full',
					name = L["Quest Progression to Party Chat"],
					desc = L["Prints the Quest Progression Status to the Party Chat"],
				},
				autocomplete = {
					type = 'toggle',
					order = 10,
					width = 'full',
					name = L["Auto Complete Quest"],
					desc = L["Automatically Complete Quests"],
				},		
				alpha = {
					type = 'range',
					order = 11,
					name = L["Quest Log Alpha"],
					desc = L["Sets the Alpha of the Quest Log"],
					set = function(info, value)	db.questlog[ info[#info] ] = value QuestLogFrame:SetAlpha(value) end,
					min = 0,
					max = 1,
					isPercent = true,
					step = 0.01,
				},
				fontsize = {
					type = 'range',
					order = 12,
					name = L["Font Size"],
					set = function(info, value) db.questlog[ info[#info] ] = value keql:SetQuestLogFontSize(value) end,
					min = 6,
					max = 20,
					step = 1,
				},
				scale = {
					type = 'range',
					order = 13,
					name = L["Quest Log Scale"],
					desc = L["Sets the Scale of the Quest Log"],
					--get = function(info) return keql.db.profile.QuestLogScale end,
					set = function(info, value) db.questlog[ info[#info] ] = value QuestLogFrame:SetScale(value) end,
					isPercent = true,
					min = 0.50, max = 1.50, step = 0.01,
				},
			},
		},
-- Quest Log Options
-- Questtracker Options
		colors = {
			type  = 'group',
			order = 2,
			name = L["Colors"],
			get = function(info)
				local t = db.colors[ info[#info] ]
				return t.r, t.g, t.b, t.a
			end,
			set = function(info, r, g, b, a)
				local t = db.colors[ info[#info] ]
				t.r, t.g, t.b, t.a = r, g, b, a
				QuestWatch_Update()
			end,
			args = {
				intro = {
					order = 1,
					type = "description",
					name = L["keql_COLOR_DESC"],
				},
				reset = {
					type = "execute",
					order = 2,
					name = L["Reset colors"],
					func = function(info)
						db.colors = nil
						keql.db:RegisterDefaults(defaults)
						QuestWatch_Update()
					end
				},
				tracker = {
					type  = 'group',
					order = 3,
					name = L["Tracker"],
					guiInline = true,
					args = {
						TrackerBGColor = {
							type = "color",
							order = 1,
							name = L["Background"],
							hasAlpha = true,
						},
						TrackerBorderColor = {
							type = "color",
							order = 2,
							name = L["Border"],
							hasAlpha = true,
						},
						ZoneColor = {
							type = "color",
							order = 3,
							name = L["Zone"],
						},
						ObjectiveColor = {
							type = "color",
							order = 4,
							name = L["Objective"],
						},
						ObjectiveColorCompleted = {
							type = "color",
							order = 5,
							name = L["Objective Completed"],
						},
						Spacing1 = {
							type = 'header',
							order = 6,
							name = '',
						},
						QuestColor = {
							type = "color",
							order = 7,
							name = L["Quest Title"],
							disabled = function() return db.colors.QuestColorLevels end,
						},
						QuestColorCompleted = {
							type = "color",
							order = 8,
							name = L["Quest Completed"],
							disabled = function() return db.colors.QuestColorLevels end,
						},
						QuestColorFailed = {
							type = "color",
							order = 9,
							name = L["Quest Failed"],
							disabled = function() return db.colors.QuestColorLevels end,
						},
					},
				},
				tooltip = {
					type  = 'group',
					order = 4,
					name = L["Tooltip"],
					guiInline = true,
					args = {
						tooltipquest = {
							type = "color",
							order = 1,
							name = L["Quest Text"],
							disabled = function() return db.colors.QuestColorLevels end,
						},
						tooltiptext = {
							type = "color",
							order = 2,
							name = L["Tooltip Text"],
						},
					},
				},
				QuestColorLevels = {
					type = "toggle",
					order = 5,
					get = function(info) return db.colors[ info[#info] ] end,
					set = function(info, value) db.colors[ info[#info] ] = value QuestWatch_Update() end,
					name = L["Use Quest Difficulty"],
					desc = L["Use ingame quest difficulty coloring for all quest titles"],
					--width = "double",
				},
				objfade = {
					type = "toggle",
					order = 6,
					name = L["Fade Objective Color"],
					desc = L["Fades from Red to Green depending on percent completed"],
					get = function(info) return db.colors[ info[#info] ] end,
					set = function(info, value) db.colors[ info[#info] ] = value end,
				},
			},
		},
		tracker  = {
			type	= 'group',
			order   = 3,
			get = function(info) return db.tracker[ info[#info] ] end,
			set = function(info, value) db.tracker[ info[#info] ] = value end,
			--name = L["Disable Tracker"],
			--desc = L["Disable the Tracker"].." - "..L["Requires Interface Reload"],
			args	= {
				intro = {
					order = 1,
					type = "description",
					name = L["keql_TRACK_DESC"],
				},
				locked = {
					type = 'toggle',
					order = 2,
					name = L["Lock Tracker"],
					desc = L["Makes the quest tracker unmovable"],
					--get = function(info) return keql.db.profile.lockedtracker end,
					set = function(info, value)
						db.tracker[ info[#info] ] = value
						if value then
							QuestWatchFrame:RegisterForDrag(0)
							keql.TrackerTitleBar:RegisterForDrag(0)
						else
							QuestWatchFrame:RegisterForDrag("LeftButton")
							keql.TrackerTitleBar:RegisterForDrag("LeftButton")
						end
						keql:CheckMouseEvents()
					end,
					disabled = function(info) return db.disabled.lockedtracker end,
				},
				resettracker = {
					type = 'execute',
					order = 3,
					name = L["Reset tracker position"],
					func = function(info)
						QuestWatchFrame:ClearAllPoints()
						QuestWatchFrame:SetPoint("TOPLEFT","UIParent","Center",0,0)
						keql:SavePositionTracker()
					end
				},
				trackerheader = {
					type = 'toggle',
					order = 4,
					name = L["Show Tracker Header"],
					desc = L["Shows the trackers header"],
					set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
				},
				fontheight = {
					type = 'range',
					order = 5,
					name = L["Font Size"],
					desc = L["Changes the font size of the tracker"],
					--get = function(info) return keql.db.profile.TrackerFontHeight end,
					set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
					min = 8,
					max = 18,
					step = 1,
				},	
				alpha = {
					type = 'range',
					order = 6,
					name = L["Quest Tracker Alpha"],
					desc = L["Sets the Alpha of the Quest Tracker"],
					--get = function(info) return keql.db.profile.QuestTrackerAlpha end,
					set = function(info, value) db.tracker[ info[#info] ] = value QuestWatchFrame:SetAlpha(value) end,
					min = 0,
					max = 1,
					isPercent = true,
					step = 0.01,
				},							
				addnewquests = {
					type = 'toggle',
					order = 7,
					name = L["Add New Quests"],
					desc = L["Automatical add new Quests to tracker"],
					set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
				},
				addobjectiveupdate = {
					type = 'toggle',
					order = 8,
					name = L["Add Untracked"],
					desc = L["Automatical add quests with updated objectives to tracker"],
					set = function(info, value) db.tracker[ info[#info] ] = value
						if value then
							AUTO_QUEST_WATCH = "1"
						else
							AUTO_QUEST_WATCH = "0"
						end
						QuestWatch_Update() 
					end,
				},									
				showzones = {
					order = 9,
					type = 'toggle',
					name = L["Show Quest Zones"],
					desc = L["Show the quests zone it belongs to above its name"],
					set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
				},			
				WatchOptions = {
					type = 'group',
					order = 10,
					inline = true,
					guiInline = true,
					name = L["Watch Options"],
					args = {
						removecompleted = {
							type = 'toggle',
							order = 1,
							width = 'full',
							name = L["Remove Completed"],
							desc = L["Automatical remove completed quests from tracker"],
							--get = function(info) return keql.db.profile.RemoveFinished end,
							set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
						},
						hidecompletedobj = {
							type = 'toggle',
							order = 2,
							width = 'full',
							name = L["Hide Completed Objectives"],
							desc = L["Automatical hide completed objectives in tracker"],
							--get = function(info) return keql.db.profile.MinimizeFinished end,
							set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
						},
						hidequestcompletedobj = {
							type = 'toggle',
							order = 3,
							width = 'full',
							name = L["Hide Objectives for Completed only"],
							desc = L["Hide objectives only for completed quests"],
							--get = function(info) return keql.db.profile.HideCompletedOnly end,
							set = function(info, value) db.tracker[ info[#info] ] = value QuestWatch_Update() end,
							disabled = function(info) return db.tracker.hidecompletedobj or db.tracker.removecompleted end,
						},
					},
				},
				colors = {
					order = 11,
					type = "description",
					name = L["Quest Tracker color options have moved to the Colors submenu"],
				},
			},
		},
-- Tooltip Options
		tooltip = {
			type  = 'group',
			order = 4,
			name = L["Tooltip"],
			get = function(info) return db.tooltip[ info[#info] ] end,
			set = function(info, value) db.tooltip[ info[#info] ] = value end,
			desc = L["Tooltip Options"],
			args  = {
				intro = {
					order = 1,
					type = "description",
					name = L["keql_TIP_DESC"],
				},
				showmob = {
					type = 'toggle',
					order = 2,
					name = L["Mob Tooltip Quest Info"],
					desc = L["Show quest info in mob tooltips"],
				},
				showitem = {
					type = 'toggle',
					order = 3,						
					name = L["Item Tooltip Quest Info"],
					desc = L["Show quest info in item tooltips"],
				},	
				tracker = {
					type = 'group',
					guiInline = true,
					order = 4,
					name = L["Quest Tracker"],
					args = {
						activetracker = {
							type = 'toggle',
							order = 1,
							width = 'full',
							name = L["Tracker Tooltip"],
							desc = L["Showing mouseover tooltips in tracker"],
							set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
						},	
						activetrackerdesc = {
							type = 'toggle',
							order = 2,
							width = 'full',
							name = L["Quest Description in Tracker Tooltip"],
							desc = L["Displays the actual quest's description in the tracker tooltip"],
							disabled = function(info) return not db.tooltip.activetracker end,
						},		
						activetrackerleft = {
							type = 'toggle',
							order = 3,							
							name = L["Enable Left Click"],
							desc = L["Left clicking a quest in the tracker opens the Quest Log"],
							--get = function(info) return keql.db.profile.activetrackerleft end,
							set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
							disabled = function(info) return not db.tooltip.activetracker end,
						},
						activetrackerright = {
							type = 'toggle',
							order = 4,							
							name = L["Enable Right Click"],
							desc = L["Right clicking a quest in the tracker removes it from the tracker"],
							--get = function(info) return keql.db.profile.activetrackerright end,
							set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
							disabled = function(info) return not db.tooltip.activetracker end,
						},
					},
				}, 			
			},		
		},
		achievement = {
			type  = 'group',
			order = 4,
			name = L["Tooltip"],
			get = function(info) return db.achievement[ info[#info] ] end,
			set = function(info, value) db.achievement[ info[#info] ] = value end,
			desc = L["Tooltip Options"],
			args  = {
				intro = {
					order = 1,
					type = "description",
					name = L["keql_ACHIEVE_DESC"],
				},
				manage = {
					type = 'toggle',
					order = 2,
					name = L["Mob Tooltip Quest Info"],
					desc = L["Show quest info in mob tooltips"],
				},
				anchor = {
					type = 'toggle',
					order = 3,						
					name = L["Item Tooltip Quest Info"],
					desc = L["Show quest info in item tooltips"],
				},	
				tracker = {
					type = 'group',
					guiInline = true,
					order = 4,
					name = L["Quest Tracker"],
					args = {
						activetracker = {
							type = 'toggle',
							order = 1,
							width = 'full',
							name = L["Tracker Tooltip"],
							desc = L["Showing mouseover tooltips in tracker"],
							--set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
						},	
						activetrackerdesc = {
							type = 'toggle',
							order = 2,
							width = 'full',
							name = L["Quest Description in Tracker Tooltip"],
							desc = L["Displays the actual quest's description in the tracker tooltip"],
							disabled = function(info) return not db.tooltip.activetracker end,
						},		
						activetrackerleft = {
							type = 'toggle',
							order = 3,							
							name = L["Enable Left Click"],
							desc = L["Left clicking a quest in the tracker opens the Quest Log"],
							--get = function(info) return keql.db.profile.activetrackerleft end,
							--set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
							disabled = function(info) return not db.tooltip.activetracker end,
						},
						activetrackerright = {
							type = 'toggle',
							order = 4,							
							name = L["Enable Right Click"],
							desc = L["Right clicking a quest in the tracker removes it from the tracker"],
							--get = function(info) return keql.db.profile.activetrackerright end,
							--set = function(info, value) db.tooltip[ info[#info] ] = value keql:CheckMouseEvents() end,
							disabled = function(info) return not db.tooltip.activetracker end,
						},
					},
				}, 			
			},		
		},
	},
}

function addon:SetupOptions()
	self.optionsFrames = {}

	-- setup options table
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Extended QuestLog", options)
	local ACD3 = LibStub("AceConfigDialog-3.0")

	-- The ordering here matters, it determines the order in the Blizzard Interface Options
	self.optionsFrames.keql = ACD3:AddToBlizOptions("Extended QuestLog", nil, nil, "general")
	self.optionsFrames.colors = ACD3:AddToBlizOptions("Extended QuestLog", L["Colors"], "Extended QuestLog", "colors")
	self.optionsFrames.qtracker = ACD3:AddToBlizOptions("Extended QuestLog", L["Quest Tracker"], "Extended QuestLog", "tracker")
	self.optionsFrames.tooltip = ACD3:AddToBlizOptions("Extended QuestLog", L["Tooltip Settings"], "Extended QuestLog", "tooltip")
	
	-- Achievement rewrite not done:
	--self.optionsFrames.tooltip = ACD3:AddToBlizOptions("Extended QuestLog", L["Achievement Settings"], "Extended QuestLog", "achievement")
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), L["Profiles"])
	-- Add ordering data to the option table generated by AceDBOptions-3.0
	options.args.Profiles.order = -2
end

function addon:OpenOptions()
	InterfaceOptionsFrame_OpenToCategory(keql.optionsFrames["qtracker"])
	InterfaceOptionsFrame_OpenToCategory(keql.optionsFrames["keql"])
end

function addon:Toggle()
	ToggleFrame(QuestLogFrame)
end

function keql:RegisterModuleOptions(name, optionTbl, displayName)
	options.args[name] = (type(optionTbl) == "function") and optionTbl() or optionTbl
	self.optionsFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Extended QuestLog", displayName, "Extended QuestLog", name)
end

function keql:CheckMouseEvents()
	if not db.tooltip.activetracker and not db.tooltip.activetrackerleft and not db.tooltip.activetrackerright and db.tracker.locked then
		QuestWatchFrame:EnableMouse(false)
		keql.TrackerTitleBar:EnableMouse(false)
	else
		QuestWatchFrame:EnableMouse(true)
		keql.TrackerTitleBar:EnableMouse(true)
	end
end

--- EOF ---